; a test of the agent system mostly devised to show what is going on

(load "agents")

(defparameter *agents* nil)
(defconstant  +tick+ 10 "energy cost per iteration of energy system")
(defparameter *time* 0  "world time (if you need that)")

(block nil (setq *random-state* (make-random-state t)) (return))
(defun coinflip? () (zerop (random 2)))
(defun a-few-ticks () (* +tick+ (1+ (random 6))))

(defun dosomething (ent)
  (declare (agent ent))
  (format t "~&~a RUN ~a~&" *time* (agent-stash ent))
  (when (coinflip?)
    (let ((value (a-few-ticks)) (id (gensym)))
      (format t "~& SPAWN ~a in ~a~&" id value)
      (new-agent :energy value :stash id))))

(defun new-agent (&key (energy (a-few-ticks))
                  (action #'dosomething)
                  (stash (gensym)))
  (make-agent :energy energy :action action :stash stash))

(defun show-agents ()
  (format t "~&~a AGENTS ~a~&" *time*
          (mapcar (lambda (e)
                    (list (agent-stash e) (agent-energy e)))
                  *agents*)))

(loop repeat 4 do (push (new-agent) *agents*))

(loop repeat 10 do
  (doagents *agents* +tick+)
  (show-agents)
  (incf *time* +tick+))